#include <iostream>
#include <fstream>
using namespace std;

const int MAXN = 200005;

ifstream inp, sol, out;

int n, a[MAXN], p[MAXN];
long long sum = 0, tot = 0;

int main(int argc, char *argv[])
{
  /*  argv[1] = "06.in";
    argv[2] = "06.sol";
    argv[3] = "01.out";*/

    inp.open(argv[1]);
    sol.open(argv[2]);
    out.open(argv[3]);

    inp >> n;
    for (int i = 1; i <= n; ++ i)
    {
        inp >> a[i];
        tot += a[i];
    }
    inp.close();

    string jury;
    sol >> jury;
    sol.close();

    if (jury == "impossible")
    {
        string part;
        out >> part;
        if (part != "impossible")
        {
            cout << 0 << endl;
            cerr << "Wrong answer" << endl;
        }
        else
        {
            cout << 1 << endl;
            cerr << "Correct answer" << endl;
        }
        out.close();
        return 0;
    }

    for (int i = 1; i <= n; ++ i)
    {
        int x;
        out >> x;
        if (!out.good() or x < 1 or x > n or p[x] != 0) // basic checks
        {
            cout << 0 << endl;
            cerr << "Wrong answer" << endl;
            out.close();
            return 0;
        }

        p[x] = i;
        if (i != 1 and p[x - 1] == 0 and p[x + 1] == 0) // not contiguous
        {
            cout << 0 << endl;
            cerr << "Wrong answer" << endl;
            out.close();
            return 0;
        }

        sum += a[x];
        if (sum * n > tot * i) // average exceeded
        {
            cout << 0 << endl;
            cerr << "Wrong answer" << endl;
            out.close();
            return 0;
        }
    }

    cout << 1 << endl;
    cerr << "Correct answer" << endl;
    out.close();

    return 0;
}
